// Adapted from DirLister v8.2 by Peter Gillespie. Thanks Pete!

typedef struct _PLAYLIST_STYLE { char path[512]; char name[128]; } PLAYLIST_STYLE;

typedef struct _GLOBALSETTINGS_STYLE {

	char		Centred [200];

	//dword		CapitalAutoTimer;		// Run Capital every 20 minutes
	int		iDirFinalCnt;			// Dir List Final Array Size
	int		iMenuItem;			// Which menu item in DirLister is selected
	PLAYLIST_STYLE	uDirList[100];			// Dir List Working Array
	PLAYLIST_STYLE	uFinalList[100];		// Dir List Final Array
	PLAYLIST_STYLE	uCurOnScreenuDir;		// Dir List Current OnScreen Dir & Path
	dword		dwWaitTime;			// Note the time elapsed
	//dword     dwWaitTime2;
	//dword		dwTotalWaitTime;		// Note the time elapsed overall
	bool		bAddDirFlag;			// Flag if user is adding a directory
	bool		bGroup01Flag;			// Flag if more than one Group 01 found
	//bool		bExitFlag;			// Exit from current FileList
	//bool 		bRenameFlag;			// Ready to rename files
	//bool 		bDoRenameFlag;			// Do a rename or just catalog files
	bool 		bShowMenuFlag;			// Show the dirlister menu onscreen
	//bool		bDirListMenuActive;		// Is the DirLister menu onscreen?
	bool		bFileFoundCount;		// How many files have been found?
	bool		bInRootDirectoryFlag;		// Is the user running DirLister from ROOT
	//bool		bDirListActive;			// Is the user running DirLister now?
	//bool		bDirMenuOnScreen;		// DirLister menu is on screen?
	bool		bActionDirLister;		// User has selected a menu option.
	bool		bFoldersMenu;			// Scroll down through the changed file list
	//bool		bDoTruCaps;			// Run a manual TruCaps event
	char		sCurrentDir[512];		// Current Directory
	//bool		bDoIt;				// Run Capital
	//bool		bResetTruScreen;		// Reset screen if done manually
	//bool		ClearTime;			// Erase Channel Text off TV screen
	//bool		FileTimerOpen;			// Has user entered a file or timer screen?
	//dword		StartUpDelay;
	//dword		myRegion;
	//bool		RecordPressed;
	//bool		ChannelChanged ;
	//bool		MadeRegion; 
	//dword 		TimePassed;
	//int		iMenuRgn;			// Menu Region Handle
	//TYPE_Window	iMenuWin;			// Menu Window Handle
	//int		iSmallMenuRgn;			// Menu Region Handle
	//TYPE_Window	iSmallMenuWin;			// Menu Window Handle
	word		iNoteMenuRgn;			// Menu Region Handle
	TYPE_Window	iNoteMenuWin;			// Menu Window Handle
	//bool		iSmallMenuRgnOn;
	bool		iNoteMenuRgnOn;


//----------------------------------------
	//bool		debug;
	//int		iMR1;			
	//TYPE_Window	iMW1;			
	//int		iMR2;		
	//TYPE_Window	iMW2;			
//----------------------------------------
	//bool		showconfigmenu;
	//bool		renameon ;	
	//dword		showregion;
	//bool		showregionOn;
	//bool		iMenuRgnOn;

//----------------------------------------
	char 		uppercase[512]; 
	char 		lowercase[512]; 
	char 		final[90]; 
   	//int 		spot;
	//bool		DoName;
	//bool		DoTime;
	//bool		IsGerman;

} GLOBALSETTINGS_STYLE;

GLOBALSETTINGS_STYLE uGbl;

//------------------------------ upper --------------------------------------
//

void upper ( char* whatword )
{
   int	iCnt;
   strupr ( whatword );
// if ( uGbl.IsGerman == TRUE ) 
//	   for ( iCnt = 0; iCnt < strlen (whatword); iCnt += 1 )
//	   {
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//	   }
}

//------------------------------ lower --------------------------------------
//

void lower ( char* whatword )
{
//   int	iCnt;

   strlwr ( whatword );
//   if ( uGbl.IsGerman == TRUE ) 
//	   for ( iCnt = 0; iCnt < strlen (whatword); iCnt += 1 )
//	   {
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//		if ( whatword[iCnt] == '' ) whatword[iCnt] = '';
//	   }
}

//---------------------------- IsSomethingRec -----------------------------------
//

bool	IsSomethingRec()
{
	bool 		RecOn1 = FALSE ;
	bool		RecOn2 = FALSE ;
	TYPE_RecInfo 	IsRecording ;
	
	//modified by mike
	
	if (TAP_Hdd_GetRecInfo (0, &IsRecording)) {
		if ( IsRecording.recType == RECTYPE_Normal) return TRUE;
	}
	if (TAP_Hdd_GetRecInfo (1, &IsRecording)) {
		if ( IsRecording.recType == RECTYPE_Normal) return TRUE;
	}
	return FALSE;
}

//------------------------------ isFileRec --------------------------------------
//
bool	IsFileRec( char *sRecFile )
{
	//modified by mike
	
	char sBuff[4];
	int len;
	
	len = strlen(sRecFile);
	if (len > 4) {
		strcpy( sBuff, sRecFile + len - 4);
		strlwr( sBuff);
		if (strcmp(sBuff, ".rec") == 0)
			return TRUE;
	}
	
	return FALSE;
	
}

//------------------------------ ChangeDirRoot --------------------------------------
//
void	ChangeDirRoot()
{
	TYPE_File	fp;
	int		iNdx;

	iNdx = 0;
	TAP_Hdd_FindFirst( &fp );

//	Loop until Root found allow maximum of 20 levels

	while ( ( strcmp( fp.name, "__ROOT__" ) != 0 ) && ( iNdx < 20 ) )
	{
		TAP_Hdd_ChangeDir( ".." );
		TAP_Hdd_FindFirst( &fp );
	}
	memset( uGbl.sCurrentDir, 0, sizeof uGbl.sCurrentDir );

}

//------------------------------ GetInteger --------------------------------------
//

// Peter's code modified by Mike to allow this function to read numbers as far
// as they go, not just when terminated by the end of a string "\0"
int	GetInteger( char* sString )
{

	int iValue, iNdx, iLen;
	bool	bNegate;

	bNegate = FALSE;
	//iLen = strlen( sString ); // removed by Mike
	iLen = strspn(sString,"-0123456789"); // added by Mike
	iValue = 0;

	for ( iNdx = 0; iNdx < iLen; iNdx += 1 )				
	{
		if ( sString[iNdx] == 45 )
		{
			bNegate = TRUE;
		}
		else
		{
			if ( sString[iNdx] < 48 || sString[iNdx] > 57 )
				return 0;
			iValue = ( iValue * 10 ) + ( sString[iNdx] - 48 );
		}
	}

	if ( bNegate == TRUE )
		iValue = iValue * -1;

	return iValue;
}


//------------------------------ CentreText --------------------------------------
//
void	CentreText( char* sMesg1 )
{
	dword		dwWidth;
	int 		iNdx, spaces ;
//	char		intAlpha[200];

	memset( uGbl.Centred, 0, sizeof uGbl.Centred );
	dwWidth = TAP_Osd_GetW( sMesg1, 0, FNT_Size_1622 );
	spaces = ( ( ( 265 - dwWidth ) / 2 ) / 6 );
	iNdx = 1 ;
	while  ( iNdx  <= spaces ) { strcat ( uGbl.Centred, " " ); iNdx++;}
	strcat ( uGbl.Centred, sMesg1 );
}

//------------------------------ ExtractField --------------------------------------
//
void	ExtractField ( char* sParam, int iDelim, int iFieldNdx, char* sResult )
{
	int	iNdx, iRecSize, ibNdx, iFieldCnt;
	bool	bFound;
	char	sTemp[512], sBuff[200];

	memset( sResult, 0, sizeof sResult );
	memset( sTemp, 0, sizeof sTemp );

	iRecSize = strlen( sParam );
	ibNdx = 0;
	iFieldCnt = 1;
	bFound = FALSE;
	
	for ( iNdx = 0; iNdx < iRecSize; iNdx += 1 )				
	{
		if ( iFieldCnt == iFieldNdx ) bFound = TRUE;

		if ( sParam[iNdx] == iDelim )
		{
			if ( bFound == TRUE ) break;
			iFieldCnt = iFieldCnt + 1;
		}
		else
		{
			if ( bFound == TRUE )
			{
				sTemp[ibNdx] = sParam[iNdx];
				if ( ibNdx < 512 ) ibNdx = ibNdx + 1;					
			}
		}
	}

	if ( bFound == TRUE ) strcpy( sResult, sTemp );
}

//------------------------------ ChangeDir --------------------------------------
//
bool	ChangeDir( char* sDir )
{
	char	sResult[512] ;
	int	iNdx;

	memset( sResult, 0, sizeof sResult );
	iNdx = 1;
	ExtractField( sDir, 92, iNdx, sResult );

	while ( strlen( sResult ) > 0 )
	{
		if ( strlen( uGbl.sCurrentDir ) != 0 )	strcat( uGbl.sCurrentDir, "\\" );
		strcat( uGbl.sCurrentDir, sResult );
		TAP_Hdd_ChangeDir ( sResult );
		iNdx = iNdx + 1;
		ExtractField( sDir, 92, iNdx, sResult );
	}
	return TRUE;
}

//------------------------------ Note Create --------------------------------------

void	NoteMenuCreate( char* Text1, char* Text2, int Delay )
{
	int	iCol, iRow, iHeight, iWidth;

	iWidth = 260;
	if (strlen (Text2) != 0 ) iHeight = 80; else iHeight = 60;
	iCol = 65 ; 
	iRow = 28 ; 
	if ( uGbl.iNoteMenuRgnOn == FALSE ) 
	{ 
		uGbl.iNoteMenuRgn = TAP_Osd_Create ( 150, 100, 320, 376, 0, OSD_Flag_Plane2 ); // modified to plane 2 by mike
		uGbl.iNoteMenuRgnOn = TRUE; 
	}


	TAP_Win_SetDefaultColor (&uGbl.iNoteMenuWin);
	TAP_Win_Create ( &uGbl.iNoteMenuWin, uGbl.iNoteMenuRgn, iCol, iRow, iWidth, iHeight, TRUE, FALSE );
	TAP_Win_SetTitle( &uGbl.iNoteMenuWin, TAP_NAME, 0, FNT_Size_1622 );
	TAP_Win_AddItem( &uGbl.iNoteMenuWin, "" );
	CentreText (Text1); 
	TAP_Win_AddItem( &uGbl.iNoteMenuWin, uGbl.Centred ); 	
	if (strlen (Text2) != 0 ) 
	{
		CentreText (Text2);
		TAP_Win_AddItem( &uGbl.iNoteMenuWin, uGbl.Centred ); 
	}
 	TAP_Win_AddItem( &uGbl.iNoteMenuWin, "" );
	TAP_Delay ( Delay );
}

//------------------------------ DirLister --------------------------------------
//
			
void	DirLister ( char* sDir )
{
	TYPE_File	fp;
	dword		dwCnt, dwNdx, dwStartTick;
	bool		bMoreFiles, bLoadFile, foundDir;
	int		iNdx, dwDir, dwFnl; 
	char		CurDir [512], LoopDir [512], NameDir [100], CurSaveDir [100], CurSavePathDir [512], sTemp [512];


//	Clean out the array.
	for ( iNdx = 0; iNdx < 100; iNdx++ ) 
	{
		memset( uGbl.uDirList[iNdx].name, 0, sizeof uGbl.uDirList[iNdx].name );
		memset( uGbl.uDirList[iNdx].path, 0, sizeof uGbl.uDirList[iNdx].path );
		memset( uGbl.uFinalList[iNdx].name, 0, sizeof uGbl.uFinalList[iNdx].name );
		memset( uGbl.uFinalList[iNdx].path, 0, sizeof uGbl.uFinalList[iNdx].path );
	}

//	Change to the main directory
	dwStartTick = TAP_GetTick();
	memset ( sTemp, 0, sizeof sTemp);	
	dwDir = 1; dwFnl = 0;
	strcpy ( sTemp, sDir );
	strcpy ( uGbl.uDirList[dwDir].name, sDir );
	strcpy( uGbl.uDirList[dwDir].path, sDir );

//	If root directory then don't append the slash
	if ( strcmp ( sTemp, "" ) != 0 ) strcat ( uGbl.uDirList[dwDir].path, "\\" ); 

// 	Loop while we still have directories to be scanned
	while (dwDir > 0)
        {
	        ChangeDirRoot();
 		ChangeDir( uGbl.uDirList[dwDir].path );
		memset ( CurDir, 0, sizeof CurDir);
		memset ( CurSaveDir, 0, sizeof CurSaveDir);
		memset ( CurSavePathDir, 0, sizeof CurSavePathDir);
		strcpy ( CurDir, uGbl.uDirList[dwDir].path );
		strcpy ( CurSaveDir, uGbl.uDirList[dwDir].name );
		strcpy ( CurSavePathDir, uGbl.uDirList[dwDir].path );
	        dwDir--;
	
		dwCnt = TAP_Hdd_FindFirst( &fp );
		bMoreFiles = ( dwCnt != 0 );
		foundDir = FALSE;

//		If files exist locate all directories in the current directory
		if ( bMoreFiles == TRUE )
		{
			for ( iNdx = 1; iNdx <= dwCnt ; iNdx += 1 )
			{
//				Find Folders Routine
	  			if ( ( fp.attr == ATTR_FOLDER ) )
				{
					memset ( LoopDir, 0, sizeof LoopDir);
					memset ( NameDir, 0, sizeof NameDir);
					strcpy( LoopDir, CurDir );
					strcpy ( NameDir, fp.name );
					strcat ( LoopDir, fp.name ); 
				        strcat ( LoopDir, "\\" );

//					If a GROUP 01 folder is found then you are in current user directory.
//					Do not add GROUP 01 folders to the final list.
 		            if ( strcmp ( NameDir, GROUP01 ) == 0 ) 
					{
							uGbl.bGroup01Flag = TRUE;
							memset ( uGbl.uCurOnScreenuDir.path, 0, sizeof uGbl.uCurOnScreenuDir.path);
							memset ( uGbl.uCurOnScreenuDir.name, 0, sizeof uGbl.uCurOnScreenuDir.name);
							strcpy ( uGbl.uCurOnScreenuDir.path, CurSavePathDir );
							strcpy ( uGbl.uCurOnScreenuDir.name, CurSaveDir );

					}
					else
//					If not GROUP 01 then add folder name to temporary and final lists.
					{
					dwDir++;
					strcpy( uGbl.uFinalList[dwFnl].name, NameDir );
					strcpy( uGbl.uDirList[dwDir].name, NameDir );
					strcpy( uGbl.uFinalList[dwFnl].path, LoopDir );
					strcpy( uGbl.uDirList[dwDir].path, LoopDir );
					dwFnl++;
					}
					TAP_Hdd_FindNext( &fp );
	 			}
        	                else
	 			{
					TAP_Hdd_FindNext( &fp );
				}
			}
		}
	}
//	Set global couter for number of directories found and return
	dwFnl--;
	uGbl.iDirFinalCnt = dwFnl;
}

